
import yoda
from math import sqrt

wplus = 'wplus.yoda'
wminus = '' # checks same file if empty string
#wminus = 'wminus.yoda'

phists = yoda.read( wplus )
tags = sorted(phists.keys())

mhists = yoda.read( wminus if wminus else wplus )

outName = '%s_post.yoda' % wplus[:-5]
print 'Post-processing output going into', outName
f = open(outName, 'w')
for h in tags:
  if wminus and 'ATLAS_2016_I1502620_W/d10' in h:
    phists[h] = mhists[h]

  if 'ATLAS_2016_I1502620_W/d35' in h:
    hp = phists[ h.replace('d35', 'd09') ]
    hm = mhists[ h.replace('d35', 'd10') ]
    for i in range(phists[h].numPoints):
      asum = hp.bins[i].height + hm.bins[i].height
      val = 0.; err = 0.
      if asum:
        pos2  = hp.bins[i].height ** 2
        min2  = hm.bins[i].height ** 2
        errp2 = hp.bins[i].heightErr ** 2
        errm2 = hm.bins[i].heightErr ** 2
        val = (hp.bins[i].height - hm.bins[i].height) / asum
        err = 2. * sqrt(errm2 * pos2 + errp2 * min2) / asum ** 2;

      phists[h].points[i].y = val
      phists[h].points[i].yErrs = (err, err)
  yoda.writeYODA(phists[h], f)
f.close()

